<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Assignment extends Model
{
	protected $table = 'project_revisor';

	protected $fillable = [ 'project_id', 'revisor_id', 'stage_id', 'group_id'];

	public $timestamps = true;


	// RELACIONES:
    
	public function project(){
        return $this->belongsTo('App\Project', 'project_id', 'id');
    }

    public function revisor(){
        return $this->belongsTo('App\User', 'revisor_id', 'id');
    }

    public function stage(){
        return $this->belongsTo('App\Stage', 'stage_id', 'id');
    }

    public function group(){
        return $this->belongsTo('App\Group', 'group_id', 'id')->withDefault(['name' => 'sin grupo']);
    }
}
