<?php

namespace App\Http\Controllers\admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

use App\Project;
use App\User;
use App\Group;

use DB;
use Auth;
use Session;

class AsignatorsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request){

        if (isset($_GET['filtroPais'])) {
            $idPais = $_GET['filtroPais'];
        }else{
            $idPais = null;
        }

        if (isset($_GET['filtroTipoInscripcion'])) {
            $idTipoInscripcion = $_GET['filtroTipoInscripcion'];
        }else{
            $idTipoInscripcion = null;
        }

        if (isset($_GET['filtroResenia'])) {
            $idResenia = $_GET['filtroResenia'];
        }else{
            $idResenia = null;
        }



        $user = Auth::user();

        $stage = DB::table('stages')
                            ->where('active', '=', 1)
                            ->get();
        $etapa_activa = $stage->pluck('id')->first();


        //Lista de proyectos
        if ($user->hasRole('superadmin') || $user->hasRole('administrador')) {

            //  Verificar si quiero traer por grupo o por revisor
            if(!empty($request->filtroEtapa)){
                $dataType = explode("_", $request->idRevisor);

                // Por grupo
                if($dataType[0]=="g"){
                    $proyectoYaAsignado = DB::table('project_revisor')
                                    ->get();

                    $coleccion = collect();
                    foreach ($proyectoYaAsignado as $key => $value) {
                        
                        if ($value->group_id == $dataType[1]) {
                            $coleccion->push($value);
                        }elseif ($value->stage_id == $request->filtroEtapa && !is_null($value->group_id)) {
                                $coleccion->push($value);
                        }

                    }


                    $proyectos = \DB::table('projects')
                                    ->where('projects.title', '<>', NULL)
                                    ->where('projects.active', '=', 1)
                                    ->orderBy('origin_id', 'asc')
                                    ->get();

                    $proyectosDisponibles = $proyectos->whereNotIn('id', $coleccion->pluck('project_id')->toArray());

                    $projects = array();
                    foreach ($proyectosDisponibles as $key => $value) {
                        if(empty($projects[$value->id])){
                            $projects[$value->id] = $value;
                        }
                    }


                    // agregar si reseño o no
                        $evaluados = $this->filtroResenia(1);
                        $enProceso = $this->filtroResenia(2);
                        $noEvaluadosQuitar = $this->filtroResenia(3);
                    
                    // dd($noEvaluadosQuitar);

                    foreach ($projects as $key => $value) {

                        if (in_array($value->id, $evaluados)) {
                            $value->reseniado = 'EVALUADO';
                        }elseif (in_array($value->id, $enProceso)) {
                            $value->reseniado = 'EN PROCESO';
                        }else{
                            $value->reseniado = 'NO EVALUADO';
                        }

                        // if (in_array($value->id, $noEvaluadosQuitar)) {
                        //     $value->reseniado = 'NO EVALUADO';
                        // }
                    }

                }else{
                    //   Por revisor
                    $proyectoYaAsignado = DB::table('project_revisor')
                                    ->get();

                    $coleccion = collect();

                    foreach ($proyectoYaAsignado as $key => $value) {
                        //sin grupos y estricto
                        // if ($value->revisor_id == $request->idRevisor) {
                        //     $coleccion->push($value);
                        // }elseif ($value->stage_id == $request->idStage) {
                        //     $coleccion->push($value);
                        // }

                        //Sin restriccion, no probado
                        if ($value->stage_id == $request->filtroEtapa) {
                            $coleccion->push($value);
                        }

                    }
                    // dd($coleccion);
                    // dd($proyectoYaAsignado);


                    $proyectos = \DB::table('projects')
                                    ->where('projects.title', '<>', NULL)
                                    ->where('projects.active', '=', 1)
                                    ->orderBy('origin_id', 'asc')
                                    ->get();

                    $proyectosDisponibles = $proyectos->whereNotIn('id', $coleccion->pluck('project_id')->toArray());

                    // dd($proyectosDisponibles);

                    $projects = array();

                    foreach ($proyectosDisponibles as $key => $value) {

                        if(empty($projects[$value->id])){
                            $projects[$value->id] = $value;
                        }

                    }


                    // agregar si reseño o no
                    $evaluados = $this->filtroResenia(1);
                    $enProceso = $this->filtroResenia(2);
                    $noEvaluadosQuitar = $this->filtroResenia(3);
                    
                    // dd($noEvaluadosQuitar);

                    foreach ($projects as $key => $value) {

                        if (in_array($value->id, $evaluados)) {
                            $value->reseniado = 'EVALUADO';
                        }elseif (in_array($value->id, $enProceso)) {
                            $value->reseniado = 'EN PROCESO';
                        }else{
                            $value->reseniado = 'NO EVALUADO';
                        }

                        // if (in_array($value->id, $noEvaluadosQuitar)) {
                        //     $value->reseniado = 'NO EVALUADO';
                        // }
                    }

                }


            }else{
                $projects = Project::where('projects.title', '!=', 'null')
                                ->where('projects.active', '=', 1)

                                // filtro por pais
                                ->when(!is_null($idPais), function ($projects) use ($idPais) {
                                    
                                    $projects->join('users', 'users.id', '=', 'projects.user_id')
                                                ->join('userdata', 'userdata.user_id', '=', 'users.id')
                                                ->join('countries', 'countries.id', '=', 'userdata.country_id')

                                                ->where('countries.id', '=', $idPais);

                                })


                               // filtro por Etapa  ??? $idPais
                                ->when(!is_null($idPais), function ($projects) use ($idPais) {
                                    
                                    $projects->join('users', 'users.id', '=', 'projects.user_id')
                                                ->join('userdata', 'userdata.user_id', '=', 'users.id')
                                                ->join('countries', 'countries.id', '=', 'userdata.country_id')

                                                ->where('countries.id', '=', $idPais);

                                })

                                
                                 // filtro por tipo de proyecto
                                ->when(!is_null($idTipoInscripcion), function ($projects) use ($idTipoInscripcion) {
                                
                                    $projects->join('inscriptions', 'inscriptions.project_id', 'projects.id')
                                                ->join('types', 'types.id', '=', 'inscriptions.type_id')

                                                ->where('types.id', '=', $idTipoInscripcion);
                                })

                                // filtro por reseñado
                                ->when(!is_null($idResenia), function ($projects) use ($idResenia) {
                                    // 1 => Evaluado, 2 = > En Proceso, 3 = > NO Evaluado
                                    $proyectosFiltrados = $this->filtroResenia($idResenia);

                                    if ($idResenia == 1) {
                                        $projects->whereIn('projects.id', $proyectosFiltrados);
                                    }elseif ($idResenia == 2) {
                                        $projects->whereIn('projects.id', $proyectosFiltrados);
                                    }elseif ($idResenia == 3) {
                                        $projects->whereNotIn('projects.id', $proyectosFiltrados);
                                    }
                                })

                                // mandar datos
                                ->when(!is_null($idTipoInscripcion) || !is_null($idPais) || !is_null($idResenia), function ($projects) use ($idTipoInscripcion) {
                                    return $projects;
                                
                                })


                                ->select('projects.*')
                                // ->oldest()
                                ->orderBy('origin_id', 'asc')
                                ->get()->unique();
                                // dd($collectionFiltrado);
                                // ->get();
                                // dd($projects);
                                
                                // agregar si reseño o no
                                    $evaluados = $this->filtroResenia(1);
                                    $enProceso = $this->filtroResenia(2);
                                    $noEvaluadosQuitar = $this->filtroResenia(3);
                                
                                    // dd($noEvaluadosQuitar);
                                foreach ($projects as $key => $value) {
                                    if (in_array($value->id, $evaluados)) {
                                        $value->reseniado = 'EVALUADO';
                                    }elseif (in_array($value->id, $enProceso)) {
                                        $value->reseniado = 'EN PROCESO';
                                    }else{
                                        $value->reseniado = 'NO EVALUADO';
                                    }

                                    // if (in_array($value->id, $noEvaluadosQuitar)) {
                                    //     $value->reseniado = 'NO EVALUADO';
                                    // }
                                }

            }        

           
        }elseif ($user->hasRole('revisor')) {
            $projects = Project::join('project_revisor', 'project_revisor.project_id', '=', 'projects.id')
                                ->join('stages', 'project_revisor.stage_id', '=', 'stages.id')
                                
                                ->where('projects.title', '!=', 'null')
                                ->where('project_revisor.stage_id', '=', $etapa_activa)
                                ->where('project_revisor.revisor_id', '=', $user->id)
                                ->where('projects.active', '=', 1)

                                // ->when(!is_null($idPais), function ($projects) use ($idPais) {
                                    
                                //     return $projects->join('users', 'users.id', '=', 'projects.user_id')
                                //     ->join('userdata', 'userdata.user_id', '=', 'users.id')
                                //     ->join('countries', 'countries.id', '=', 'userdata.country_id')

                                //      ->where('countries.id', '=', $idPais);
                                // })
                                
                                ->select('projects.*')
                                
                                ->get();

            // agregar si reseño o no
            $evaluados = $this->filtroResenia(1);
            $enProceso = $this->filtroResenia(2);
            $noEvaluadosQuitar = $this->filtroResenia(3);
        
                // dd($noEvaluadosQuitar);
            foreach ($projects as $key => $value) {
                $rev = DB::table('reviews')->join('project_revisor', 'reviews.revisor_id', '=', 'project_revisor.revisor_id')
                                            ->join('stages', 'stages.id', '=', 'project_revisor.stage_id')
                        ->where('stages.active', '=', 1)
                        ->where('reviews.project_id', '=', $value->id)
                        ->where('reviews.revisor_id', '=', \Auth::id())

                        ->get();
                // dd($rev);

                if ($rev->isNotEmpty()) {
                    $value->reseniado = 'EVALUADO';
                }else{
                    $value->reseniado = 'NO EVALUADO';
                }
            }
            // dd($projects);

        }


        //Cantidad de proyectos
        if ($user->hasRole('superadmin') || $user->hasRole('administrador')) {
            if(!empty($request->filtroEtapa)){
               $total_proyectos = count($projects);
            }else{
                $total_proyectos = Project::where('title', '!=', 'null')
                                    ->where('active', '=', 1)
                                    ->count();
            }
        }elseif ($user->hasRole('revisor')) {
            $total_proyectos = Project::join('project_revisor', 'project_revisor.project_id', '=', 'projects.id')
                                    ->join('stages', 'project_revisor.stage_id', '=', 'stages.id')

                                    ->where('project_revisor.revisor_id', '=', $user->id)
                                    ->where('project_revisor.stage_id', '=', $etapa_activa)

                                    ->where('projects.title', '!=', 'null')
                                    ->where('projects.active', '=', 1)

                                    ->count();
        }


        //Listado de paises para el select  En Asignator no es necesario  
        if ($user->hasRole('superadmin') || $user->hasRole('administrador')) {
            $paises = DB::table('countries')
                            ->join('userdata', 'countries.id', '=', 'userdata.country_id')
                            ->join('users', 'users.id', 'userdata.user_id')
                            ->join('projects', 'projects.user_id', '=', 'users.id')

                            ->where('projects.active', '=', 1)
                            ->where('projects.title', '!=', 'null')

                            ->select('countries.es as pais', 'countries.id', DB::raw('count(*) as cantidadPorPais'))
                            ->groupBy('countries.es')
                        
                            ->get();
        }else{
            $paises = null;
        }

        //Listado de tipo de proyectos para el select
        if ($user->hasRole('superadmin') || $user->hasRole('administrador')) {
            $array_tipo_proyecto = DB::table('types')
                            // ->join('inscriptions', 'inscriptions.type_id', 'types.id')
                            // ->join('projects', 'projects.id', '=', 'inscriptions.project_id')
                            ->join('projects', 'projects.type', '=', 'types.slug')

                            ->where('projects.active', '=', 1)
                            ->where('projects.title', '!=', 'null')

                            ->select('types.name', 'types.id', DB::raw('count(*) as cantidadPorTipo'))
                            ->groupBy('types.name')

                            ->get();
                            // dd($array_tipo_proyecto);

        }else{
            $array_tipo_proyecto = null;
        }


        //Listado de revisores
        if ($user->hasRole('superadmin') || $user->hasRole('administrador')) {
            $listaRevisores = User::join('userdata', 'userdata.user_id', '=', 'users.id')
                                    ->select('users.id', 'userdata.name', 'userdata.surname')
                                    ->role('revisor')->get();
            // dd($listaRevisores);
        }else{
            $listaRevisores = null;
        }


        $select_asign = array();

        $sgroups = Group::get();

        if(!empty($sgroups)){
            foreach ($sgroups as $key3 => $value3) {
                array_push($select_asign, array("id"=>"g_".$value3->id,"name"=>$value3->name));
            }
        }


        if(!empty($listaRevisores)){
            foreach ($listaRevisores as $key4 => $value4) {
                array_push($select_asign, array("id"=>"r_".$value4->id,"name"=>$value4->name." ".$value4->surname));
            }

        }

        $etapas = DB::table('stages')
                            ->get()
                            ->pluck('id')
                            ->toArray();

        $args = [

            'filtroEtapa'          => (!empty($request->filtroEtapa))?$request->filtroEtapa:null,
            'idRevisor'            => (!empty($request->idRevisor))?$request->idRevisor:null,
            'projects'             => $projects,
            'total_proyectos'      => $total_proyectos,
            'paises'               => $paises,
            'array_tipo_proyecto'  => $array_tipo_proyecto,
            'select_asign'         => $select_asign,
            'etapas'               => $etapas
    
        ];

        
        return view('admin.models.asignators.collection', $args);

    }


    public function assignRevisor(Request $request){
        $dataType = explode( '_', $request->revisor);

        if($dataType[0]=="r"){
            //  Asigno Proyectos a un revisor
            foreach ($request->assigned as $key => $value) {
                DB::table('project_revisor')->insert(
                        [
                            'project_id' => $value, 
                            'revisor_id' => $dataType[1],
                            'stage_id'   => $request->etapa
                        ]
                );
            }
        }else{
            //  Asigno a grupos
            $revisoresDelGrupo = DB::table('group_revisor')
                                        ->join('users', 'users.id', '=', 'group_revisor.revisor_id')
                                        ->where('group_revisor.group_id', '=', $dataType[1])
                                        ->select('users.*')
                                        ->get();
            // dd($revisoresDelGrupo);

            foreach ($request->assigned as $keyProyecto => $valueProyecto) {
                foreach ($revisoresDelGrupo as $keyRevisor => $valueRevisor) {
                    DB::table('project_revisor')->insert(
                            [
                                'project_id' => $valueProyecto, 
                                'revisor_id' => $valueRevisor->id,
                                'group_id' => $dataType[1],
                                'stage_id' => $request->etapa
                            ]
                    );                    
                }
            }
        }

        echo json_encode(array("status"=>"ok"));
        exit;
    }




    // Funcion de filtros en listado de proyectos
    public function filtroResenia($idResenia){
        $stage = DB::table('stages')
                            ->where('active', '=', 1)
                            ->get();
        $etapa_activa = $stage->pluck('id')->first();

        if ($idResenia == 1) {
            $proyectosConAlgunResenia = DB::table('projects')->join('reviews', 'reviews.project_id', 'projects.id')

                        ->where('projects.title', '!=', 'null')
                        ->where('projects.active', '=', 1)
                        ->where('reviews.type', '=', 'review')

                        ->select('reviews.*')
                        ->orderBy('reviews.project_id')
                        ->get();
            // dd($proyectosConAlgunResenia);

            // Quitar reviews de usuarios no asignados a ese proyecto
            foreach ($proyectosConAlgunResenia as $key => $value) {
                $reviewAsignada = DB::table('project_revisor')
                                        ->where('revisor_id', '=', $value->revisor_id)
                                        ->where('project_id', '=', $value->project_id)
                                        ->where('stage_id', '=', $etapa_activa)
                                        ->get();

                // dd($reviewAsignada);
                if ($reviewAsignada->isEmpty()) {
                    $proyectosConAlgunResenia->pull($key);
                }
            }

            // dd($proyectosConAlgunResenia);


            $commentRevisorUnico = array();

            foreach ($proyectosConAlgunResenia as $key => $value) {
                if(empty($commentRevisorUnico[$value->project_id])){

                    $commentRevisorUnico[$value->project_id] = array();   
                }

                array_push($commentRevisorUnico[$value->project_id], $value->revisor_id);
            }

            $reviewsFiltradas = array();
            foreach ($commentRevisorUnico as $keyUnico => $value) {
                $reviewsFiltradas[$keyUnico] =count(array_unique($value));
            }

               // dd($reviewsFiltradas); 

            $cantidadRevisoresPorProyecto = DB::table('projects')
                                    ->join('project_revisor', 'project_revisor.project_id', '=', 'projects.id')
                        // ****
                        ->join('stages', 'stages.id', '=', 'project_revisor.stage_id')
                        ->where('stages.active', '=', 1)
                        
                        ->where('projects.title', '!=', 'null')
                        ->where('projects.active', '=', 1)
                        // ->where('project_revisor.stage_id', '=', $etapa_activa)

                        // ->where('project_revisor.group_id', '<>', NULL)

                        ->select('projects.id as idProyecto', DB::raw('count(projects.id) as cantidadRevisores'))
                        ->groupBy('projects.id')
                        ->get();

            // dd($cantidadRevisoresPorProyecto);

            $collectionFiltrado = collect();
            $arrayCadaFiltrado = array();
            $arrayIdProyectosOk = array();
            foreach ($cantidadRevisoresPorProyecto as $key => $proyecto) {
                foreach ($reviewsFiltradas as $keyIdProyecto => $reviewCantidad) {
                    if ($keyIdProyecto == $proyecto->idProyecto) {
                        if ($proyecto->cantidadRevisores <= $reviewCantidad) {
                            $arrayCadaFiltrado['idProyecto'] = $proyecto->idProyecto;
                            $arrayCadaFiltrado['cantidadRevisores'] = $proyecto->cantidadRevisores;
                            $arrayCadaFiltrado['cantidadCommentRecibida'] = $reviewCantidad;

                            $collectionFiltrado->push($arrayCadaFiltrado);
                            array_push($arrayIdProyectosOk, $keyIdProyecto);
                        }
                    }
                }
            }

            \Session::flash('detalleEvaluado', $collectionFiltrado);

            // dd($arrayFiltrado);
            // dd($collectionFiltrado);

            // $projects->whereIn('projects.id', $arrayIdProyectosOk);
            return $arrayIdProyectosOk;

        }elseif ($idResenia == 2) {
            $proyectosConAlgunResenia = DB::table('projects')->join('reviews', 'reviews.project_id', 'projects.id')

                        ->where('projects.title', '!=', 'null')
                        ->where('projects.active', '=', 1)
                        ->where('reviews.type', '=', 'review')

                        ->select('reviews.*')
                        ->orderBy('reviews.project_id')
                        ->get();
            // dd($proyectosConAlgunResenia->where('project_id', 69));

            // Quitar reviews de usuarios no asignados a ese proyecto
            foreach ($proyectosConAlgunResenia as $key => $value) {
                $reviewAsignada = DB::table('project_revisor')
                                        ->where('revisor_id', '=', $value->revisor_id)
                                        ->where('project_id', '=', $value->project_id)
                                        ->where('stage_id', '=', $etapa_activa)
                                        ->get();

                // dd($reviewAsignada);
                if ($reviewAsignada->isEmpty()) {
                    $proyectosConAlgunResenia->pull($key);
                }
            }

            // dd($proyectosConAlgunResenia->where('project_id', 69));
            
            $commentRevisorUnico = array();

            foreach ($proyectosConAlgunResenia as $key => $value) {
                if(empty($commentRevisorUnico[$value->project_id])){

                    $commentRevisorUnico[$value->project_id] = array();   
                }

                array_push($commentRevisorUnico[$value->project_id], $value->revisor_id);
            }

            $reviewsFiltradas = array();
            foreach ($commentRevisorUnico as $keyUnico => $value) {
                $reviewsFiltradas[$keyUnico] =count(array_unique($value));
            }

               // dd($reviewsFiltradas); 

            $cantidadRevisoresPorProyecto = DB::table('projects')
                                    ->join('project_revisor', 'project_revisor.project_id', '=', 'projects.id')

                        // ****
                        ->join('stages', 'stages.id', '=', 'project_revisor.stage_id')
                        ->where('stages.active', '=', 1)
                                    // ***

                        ->where('projects.title', '!=', 'null')
                        ->where('projects.active', '=', 1)
                        // ->where('project_revisor.stage_id', '=', $etapa_activa)
                        ->where('project_revisor.group_id', '<>', NULL)

                        ->select('projects.id as idProyecto', DB::raw('count(projects.id) as cantidadRevisores'))
                        ->groupBy('projects.id')
                        ->get();

            // dd($cantidadRevisoresPorProyecto);

            $collectionFiltrado = collect();
            $arrayCadaFiltrado = array();
            $arrayIdProyectosOk = array();
            foreach ($cantidadRevisoresPorProyecto as $key => $proyecto) {
                foreach ($reviewsFiltradas as $keyIdProyecto => $reviewCantidad) {
                    if ($keyIdProyecto == $proyecto->idProyecto) {
                        if ($proyecto->cantidadRevisores > $reviewCantidad) {
                            $arrayCadaFiltrado['idProyecto'] = $proyecto->idProyecto;
                            $arrayCadaFiltrado['cantidadRevisores'] = $proyecto->cantidadRevisores;
                            $arrayCadaFiltrado['cantidadCommentRecibida'] = $reviewCantidad;

                            $collectionFiltrado->push($arrayCadaFiltrado);
                            array_push($arrayIdProyectosOk, $keyIdProyecto);
                        }
                    }
                }
            }

            \Session::put('detalleEnProceso', $collectionFiltrado);

            // dd($arrayFiltrado);
            // dd($collectionFiltrado);

            // dd($projects);

            return $arrayIdProyectosOk;
            // $projects->whereIn('projects.id', $arrayIdProyectosOk);

        }elseif ($idResenia == 3) {
            $quitarEvaluados = DB::table('projects')->join('reviews', 'reviews.project_id', 'projects.id')
                        ->join('project_revisor', 'project_revisor.revisor_id', '=', 'reviews.revisor_id')
                        ->join('stages', 'stages.id', '=', 'project_revisor.stage_id')

                        ->where('stages.active', '=', 1)
                        ->where('projects.title', '!=', 'null')
                        ->where('projects.active', '=', 1)
                        ->where('reviews.type', '=', 'review')
                        
                        ->select('projects.id as idProyecto')
                        ->distinct()
                        ->get();

                        // dd($quitarEvaluados);
            $proyectosExcluidos = $quitarEvaluados->pluck('idProyecto')->toArray();

            return $proyectosExcluidos;
            // $projects->whereNotIn('projects.id', $proyectosExcluidos);
        }
    }





    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}
