<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Cviebrock\EloquentTaggable\Taggable;


class Inscription extends Model
{
    use Taggable;

    protected $table = 'inscriptions';

    protected $fillable = [ 'user_id','project_id','type_id'];

    public $timestamps = true;

    // RELACIONES:
    
   	public function project(){
        return $this->belongsTo('App\Project', 'project_id', 'id');
    }

    public function type(){
        return $this->belongsTo('App\Type', 'type_id', 'id');
    }

    public function user(){
        return $this->belongsTo('App\User', 'user_id', 'id');
    }

}
