<?php

namespace App;

use Cviebrock\EloquentSluggable\Sluggable;
use Illuminate\Database\Eloquent\Model;

class Type extends Model
{

    use Sluggable;

    protected $table = 'types';



    protected $fillable = ['name','slug'];


    public function sluggable()
    {
        return [
            'slug' => [
                'source' => 'name'
            ]
        ];
    }

    // RELACIONES:
    
    public function inscriptions(){
        return $this->hasMany('App\Inscription', 'type_id', 'id');
    }

    public function attachments(){
        return $this->hasMany('App\Attachment', 'type_id', 'id');
    }
}
