<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateUserdataTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('userdata', function (Blueprint $table) {
            $table->increments('id');
            $table->string('name')->nullable();
            $table->string('surname')->nullable();
            $table->string('fullname')->nullable();
            $table->string('dni_type')->nullable();
            $table->string('dni')->nullable();
            $table->string('address')->nullable();
            $table->string('city')->nulable();
            $table->integer('city_id')->unsigned()->nullable();
            $table->integer('country_id')->nullable();
            $table->string('nacionality')->nullable();
            $table->string('birthdate')->nullable();
            $table->string('telephone')->nullable();
            $table->string('cellphone')->nullable();
            $table->integer('user_id')->unsigned()->nullable();


            $table->foreign('user_id')->references('id')->on('users')->onDelete('cascade')->onUpdate('cascade');
            $table->foreign('city_id')->references('id')->on('cities')->onDelete('cascade')->onUpdate('cascade');

            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('userdata');
    }
}
