import * as types from './actionTypes';

import axios from 'axios';
import * as config from '../config/config';

export const sendForm = (data) => {
    return (dispatch) => {
        console.log(data);


        axios.post(config.BASE_URL + '/api/inscription-store', data)
            .then(function (response) {

                    dispatch({type: types.SUBMIT_FORM, data});
                    if (response.status === 200) {
                        localStorage.removeItem('localID-' + data.type);
                        localStorage.removeItem('values-' + data.type)
                        dispatch({type: types.SUBMIT_FORM_SUCCESS, success: 1});
                    // }
                    // else if (response.status == 401) {
                    //     alert('You should add al least one attachment');
                    } else {
                        alert('something went wrong, try again later');
                    }

                }
            )
            .catch(function (error) {
                console.log(error);
            });


    }
}

export const setDefaultValues = (id, type, lang) => {
    return (dispatch) => {

        let values = {uid: id, type: type, group: 'no', lang: lang};
        const localStorageValues = JSON.parse(localStorage.getItem('values-' + type));


        if (localStorageValues) {
            if (localStorageValues.type === type && localStorageValues.uid === id) {
                values = localStorageValues;
            }

        }

        dispatch({type: types.SET_DEFAULT_VALUES, defaultValues: values})
    }
}
