import React from 'react';
import PropTypes from 'prop-types';
import ConvocatoriaForm from './Form';

import * as actions from '../actions/formActions';
import {bindActionCreators} from 'redux';

import {connect} from 'react-redux';

const App = ({actions, localization, lang, types, type, countries, id, tags, defaultValues, success}) => {
console.log(defaultValues);
    return (
        <div className="App">
            {
                localization[lang] && defaultValues.uid && success === 0 ?
                    <ConvocatoriaForm initialValues={defaultValues} uid={id} countries={countries} type={type}
                                      types={types} tags={tags} localization={localization[lang]}
                                      onSubmit={actions.sendForm}/> : ''
            }
            { localization[lang]  && success === 1 ?
                <div className='success-container'> <div className="thanks"> {localization[lang].thanks}</div> <div className="success-message">{localization[lang].success_message}</div></div> : ''
            }

        </div>
    );
}

App.propTypes = {
    actions: PropTypes.object.isRequired,
    localization: PropTypes.object.isRequired,
    lang: PropTypes.string.isRequired,
    types: PropTypes.array.isRequired,
    countries: PropTypes.array.isRequired,
    type: PropTypes.string.isRequired,
    id: PropTypes.string.isRequired,
    tags: PropTypes.array.isRequired,
    defaultValues: PropTypes.object.isRequired,
    success: PropTypes.number.isRequired,
}

function mapStateToProps(state, ownProps) {
    return {
        localization: state.localization,
        lang: state.lang,
        types: state.types,
        type: state.type,
        id: state.id,
        countries: state.countries,
        tags: state.tags,
        defaultValues: state.defaultValues,
        success: state.success,
    }
}

function mapDispatchToProps(dispatch) {
    return {
        actions: bindActionCreators(actions, dispatch),

    };
}

export default connect(mapStateToProps, mapDispatchToProps)(App);
