import React from 'react';

import {connect} from 'react-redux'
import moment from 'moment';
import DropzoneComponent from 'react-dropzone-component';
import ReactDOMServer from 'react-dom/server';
import {validate, warn} from "./validation/validate";
import * as config from '../config/config';
import {
    Field,
    reduxForm,
    FieldArray,
    formValueSelector,
    // getFormMeta,
    // getFormSyncWarnings,
    // getFormSubmitErrors,
    // getFormError,
    // getFormAsyncErrors,
    // getFormSyncErrors,
    getFormValues
} from 'redux-form';

import {Accordion, AccordionSection} from 'redux-accordion';
import CheckboxGroup from './fields/CheckBoxGroup';
import {renderTextField} from './fields/TextField';
import {renderSelectField} from './fields/SelectField';
import {renderRadioGroup} from './fields/RadioGroup';
import {RadioButton} from 'material-ui/RadioButton'
import {renderMembers} from './fields/Members';
import {eventHandlers, imageComponentConfig} from './attachments/AttachConfig';
import MenuItem from 'material-ui/MenuItem'
// import Checkbox from 'material-ui/Checkbox'
import RemoteSubmitButton from './RemoteSubmitButton';
import {DatePicker} from 'redux-form-material-ui';

// import submit from './submit/submit';





const submit = ()=>{
    // console.log('bla');
}
const DateTimeFormat = global.Intl.DateTimeFormat;

const DateTimeFormatFr = function(...args) {
    let formatter = Intl.DateTimeFormat(...args);
    let newFormatter = {
        format: function(date) {
            let newDate = new Date(date.getTime());
            newDate.setHours(1);
            return formatter.format(newDate);
        }
    };
    return newFormatter;
};
let TypeSwitch = (lang)=>{

    switch (lang){
        case 'en':
            return
    }

}

let ConvocatoriaForm = props => {
    const {
        handleSubmit,
        // values,
        pristine,
        reset,
        submitting,
        localization,
        // hasNamesValue,
        // summaryLength,
        hasGroupValue,
        types,
        type,
        countries,
        uid,
        tags,
        // values,

        // syncErrorsProps,
        // submitErrorsProps,
    } = props

    const activeType = types.filter(item => {
        return (item.slug === type)

    });

     console.log(submitting);
    return (

        <div className="form-container">
            <div className='errorContainer'>

            </div>
            <form onSubmit={handleSubmit}>
                <h3>{localization.inscription_form}
                    <span
                        style={{fontWeight: 'bold'}}>{activeType[0]['name_'+localization.lang]}</span>
                </h3>

                {/*<Field*/}
                {/*name="birthdate"*/}
                {/*floatingLabelText="Start Date"*/}
                {/*component={DatePicker}*/}
                {/*hintText="es-AU locale"*/}
                {/*DateTimeFormat={DateTimeFormat}*/}
                {/*locale="en-AU"*/}
                {/*formatDate={new DateTimeFormat('en-AU', {*/}
                {/*day: 'numeric',*/}
                {/*month: 'numeric',*/}
                {/*year: 'numeric',*/}
                {/*}).format}*/}
                {/*firstDayOfWeek={0}*/}
                {/*/>*/}
                <div className="form-hidden">


                    <Field
                        className="form-field data-hj-whitelist"

                        name="uid"
                        type="text"
                        component={renderTextField}
                        autoComplete="uid"
                        label="id"/>


                    <Field name="type" component={renderRadioGroup}  className="form-field data-hj-whitelist">

                        {types.map((item) => (
                            <RadioButton key={item.slug}
                                         value={item.slug}
                                         label={item.name}
                            />

                        ))}
                    </Field>
                    <Field className="form-field data-hj-whitelist" name="lang" component={renderTextField} type="text" autoComplete="lang" label="Language"/> 
                </div>

                {/*<Accordion*/}
                {/*{...props}*/}
                {/*uniqId={'testAccordion'}>*/}


                {/*<AccordionSection*/}
                {/*title={localization.personal_data}*/}
                {/*openByDefault={true}*/}
                {/*>*/}
                <h4 className="form-header">{localization.personal_data}</h4>
                <div className="header-help">{localization.personal_data_text}</div>
                <div>

                    <div className="field-group">


                        <Field
                            className="form-field data-hj-whitelist"
                            name="names"
                            id="names"
                            type="text"
                            component={renderTextField}
                            autoComplete="name"
                            label={localization.names}
                        />


                        <Field
                            className="form-field data-hj-whitelist"
                            id="surname"
                            name="surname"
                            type="text"
                            autoComplete="surname"
                            component={renderTextField}

                            label={localization.surname}
                        />

                        <Field
                            className="form-field data-hj-whitelist"
                            id="email"
                            name="email"
                            type="text"
                            component={renderTextField}
                            label={localization.email}
                            autoComplete="email"

                        />
                    </div>

                </div>


                {/*</AccordionSection>*/}
                {/*<AccordionSection*/}
                {/*title={localization.aditional_data}*/}
                {/*openByDefault={true}*/}
                {/*>*/}
                <div className="field-group">
                    <Field className="form-field data-hj-whitelist" name="dni_type" id="dnitype" style={{maxWidth: '180px'}}
                           component={renderSelectField}

                           label={localization.dni_type}>
                        <MenuItem value="DNI" primaryText="DNI"/>
                        <MenuItem value="CI" primaryText="CI"/>
                        <MenuItem value="LE" primaryText="LE"/>
                        <MenuItem value="LC" primaryText="LC"/>
                        <MenuItem value="otro" primaryText={localization.other}/>
                    </Field>


                    <Field
                        className="form-field data-hj-whitelist"
                        style={{maxWidth: '250px'}}
                        id="dni"
                        name="dni"
                        type="text"
                        component={renderTextField}
                        label={localization.dni}
                        autoComplete="dni"

                    />
                    <div></div>
                </div>

                <div className="field-group">
                    <Field
                        className="form-field data-hj-whitelist"
                        id="address"
                        name="address"
                        type="text"
                        component={renderTextField}
                        label={localization.address}
                        autoComplete="address"

                    />
                </div>
                <div className="field-group">
                    <Field
                        className="form-field data-hj-whitelist"
                        id="city"
                        name="city"
                        type="text"
                        component={renderTextField}
                        label={localization.city}
                        autoComplete="city"
                    />


                    <Field className="form-field data-hj-whitelist" name="country_id" component={renderSelectField}
                           label={localization.country}>

                        {countries.map(item => <MenuItem key={item.id} value={item.id}
                                                         primaryText={item[localization.lang]}/>)}

                    </Field>
                </div>
                <div className="field-group">

                    <Field
                        className="form-field data-hj-whitelist"
                        id="nacionality"
                        name="nacionality"
                        type="text"
                        component={renderTextField}
                        label={localization.nacionality}
                        autoComplete="nacionality"
                    />

                    <Field
                        className="form-field data-hj-whitelist"
                        id="form-field data-hj-whitelist"
                        name="birthdate"
                        floatingLabelText={localization.birthdate}
                        component={DatePicker}
                        hintText="es-AU locale"
                        DateTimeFormat={DateTimeFormatFr}
                        locale="en-AU"
                        formatDate={new DateTimeFormat('en-AU', {
                            day: 'numeric',
                            month: 'numeric',
                            year: 'numeric',
                        }).format}
                        firstDayOfWeek={0}
                    />
                </div>
                <div className="field-group">
                    <Field
                        className="form-field data-hj-whitelist"
                        id="telephone"
                        name="telephone"
                        type="text"
                        component={renderTextField}
                        label={localization.telephone}
                        autoComplete="telephone"

                    />
                    <Field
                        className="form-field data-hj-whitelist"
                        id="cellphone"
                        name="cellphone"
                        type="text"
                        component={renderTextField}
                        label={localization.cellphone}
                        autoComplete="cellphone"
                    />
                </div>

                {/*</AccordionSection>*/}

                {/*<AccordionSection*/}
                {/*title="Section mas personal data"*/}
                {/*openByDefault={true}*/}
                {/*>*/}
                <br/>
                <br/>
                <hr/>
                <h4 className="form-header">{localization.team}</h4>

                <div>
                    <Field name="group" component={renderRadioGroup} className="form-radio" id="group">
                        <RadioButton
                            value="no"
                            label={localization.individual}

                        />
                        <RadioButton
                            value="yes"
                            label={localization.group}

                        />


                    </Field>
                </div>
                <br/><br/>
                {hasGroupValue === 'yes' ?
                    <div>
                        <Field
                            className="form-field data-hj-whitelist"
                            id="group_name"
                            name="group_name"
                            type="text"
                            component={renderTextField}
                            autoComplete="group_name"
                            label={localization.group_name}
                        />
                        <br/>
                        <br/>
                        <FieldArray name="members" countries={countries} localization={localization}
                                    component={renderMembers}/>
                    </div>
                    : ''}
                {/*</AccordionSection>*/}
                {/*<AccordionSection*/}
                {/*title={localization.project_info}*/}
                {/*openByDefault={true}*/}
                {/*>*/}
                <hr/>
                <h4 className="form-header">{localization.project_info}</h4>
                <div>

                    <Field
                        className="form-field data-hj-whitelist"
                        id="project_title"
                        name="project_title"
                        type="text"
                        component={renderTextField}
                        autoComplete="project_title"

                        label={localization.project_title}
                    />
                </div>
                {type === 'artist' ? <div>

                    <h4 className="form-header">{localization.project_type}</h4>
                    <div className="form-group checkbox-group">

                        {}
                        <CheckboxGroup name="tags" options={tags.map((tag) => {
                            return {
                                label: tag.name[localization.lang],
                                value: tag.slug
                            }
                        })}/>

                        {/*<Field name="tags" component={renderCheckbox} label="asdf"/>*/}
                        {/*{ tags.map(tag=>*/}

                        {/*)}*/}

                    </div>
                </div> : ''}


                <div>


                    <Field name="summary"
                           id="summary"
                           className="form-textarea data-hj-whitelist"
                           component={renderTextField}
                           label={localization.summary}
                           multiLine={true} rows={1}
                           rowsMax={10}
                           hintText={localization.summary_help}
                    />
                </div>
                <div className="count-chars">
                    {/*{summaryLength ? summaryLength.length : ''}*/}
                </div>

                <div>
                    <Field name="description"
                           id="description"
                           className="form-textarea data-hj-whitelist"
                           component={renderTextField}
                           label={localization.description}
                           multiLine={true} rows={1}
                           rowsMax={10}
                           hintText={localization.description_help}
                    />
                    <div className="count-chars">
                        {/*{descriptionLength ? descriptionLength.length : ''}*/}
                    </div>
                </div>
                <div>
                    <Field name="space"
                           id="space"
                           className="form-textarea data-hj-whitelist"
                           component={renderTextField}
                           label={localization.space}
                           multiLine={true} rows={1}
                           rowsMax={10}
                           hintText={localization.space_help}
                    />
                    <div className="count-chars">
                        {/*{descriptionLength ? descriptionLength.length : ''}*/}
                    </div>

                </div>

                <div>
                    <Field name="estimated_budget"
                           id="estimated_budget"
                           className="form-textarea data-hj-whitelist"
                           component={renderTextField}
                           label={localization.estimated_budget}
                           multiLine={true} rows={1}
                           rowsMax={10}
                           hintText={localization.estimated_budget_help}


                    />
                    <div className="count-chars">
                        {/*{descriptionLength ? descriptionLength.length : ''}*/}
                    </div>
                </div>

                <div>
                    <Field name="complementary_info"
                           id="complementary_info"
                           className="form-textarea data-hj-whitelist"
                           component={renderTextField}
                           label={localization.complementary_info}
                           multiLine={true} rows={1}
                           rowsMax={10}
                           hintText={localization.complementary_info_help}
                    />
                    <div className="count-chars">
                        {/*{complementary_infoLenght ? complementary_infoLenght.length : ''}*/}
                    </div>
                </div>
                {/*</AccordionSection>*/}
                {/*<AccordionSection*/}
                {/*title={localization.remote_video}*/}
                {/*openByDefault={true}*/}
                {/*>*/}
                <br/>
                <br/>
                <hr/>
                {/*<h4 className="form-header">{localization.remote_video}</h4>*/}

                {/*<div className="header-help">{localization.reference_material_help}</div>*/}
                <div className="field-group">
                    <Field
                        className="form-field data-hj-whitelist"

                        name="video_link"
                        type="text"
                        component={renderTextField}
                        autoComplete="video_link"
                        label={localization.video_link}/>
                    <Field
                        className="form-field data-hj-whitelist"

                        name="video_link_password"
                        type="text"
                        component={renderTextField}
                        autoComplete="video_link_password"
                        label={localization.password}/>


                </div>

                {/*<Field name="file" component='input' type="hidden"/>*/}
                {/*</AccordionSection>*/}
                {/*</Accordion>*/}
                <br/>
                <div className="buttons">
                    {/*<button type="submit" disabled={pristine || submitting}>*/}
                        {/*Submit*/}
                    {/*</button>*/}
                    <RemoteSubmitButton localization={localization } submitting={submitting}/>
                    <button type="button" disabled={pristine || submitting} onClick={reset}>
                        Clear Values
                    </button>
                </div>

            </form>
            <br/><br/>

            <hr/>
            <h4 className="form-header">Video <span>{localization.video_upload_help}</span></h4>
            <DropzoneComponent
                config={imageComponentConfig}
                eventHandlers={eventHandlers}
                djsConfig={{
                    addRemoveLinks: false,
                    acceptedFiles: "video/mp4",
                    maxFilesize:10,
                    maxFiles:1,
                    timeout:180000,
                    params: {
                        uid: uid,
                        type: type,
                    },
                    dictDefaultMessage: localization.upload_video,

                    previewTemplate: ReactDOMServer.renderToStaticMarkup(
                        <div className="table table-striped files" id="previews">
                            <div id="template" className="file-row">
                                <div>
                                    {/*<span className="preview"><img alt="thumb" data-dz-thumbnail/></span>*/}
                                </div>
                                <div>
                                    <p className="name" data-dz-name></p>
                                    <strong className="error text-danger" data-dz-errormessage></strong>
                                </div>
                                <div>
                                    <p className="size" data-dz-size></p>
                                    <div className="progress progress-striped active" role="progressbar"
                                         aria-valuemin="0"
                                         aria-valuemax="100" aria-valuenow="0">
                                        <div className="progress-bar progress-bar-success" data-dz-uploadprogress></div>
                                    </div>
                                </div>
                                <div className="button-container">
                                    <button data-dz-remove className="btn btn-danger delete">
                                        <span>X</span>
                                    </button>
                                </div>
                            </div>
                        </div>
                    )
                }}

                action={config.BASE_URL + '/api/upload'}
            />
            <br/>
            <br/>
            <hr/>
            <h4 className="form-header">{localization.images} <span>{localization.images_upload_help}</span></h4>
            <DropzoneComponent
                config={imageComponentConfig}
                eventHandlers={eventHandlers}
                message="bla"
                djsConfig={{
                    addRemoveLinks: false,
                    acceptedFiles: "image/jpeg",

                    dictDefaultMessage: localization.upload_images,
                    maxFilesize:2,
                    maxFiles:10,
                    timeout:180000,
                    params: {
                        uid: uid,
                        type: type,
                    },
                    previewTemplate: ReactDOMServer.renderToStaticMarkup(
                        <div className="table table-striped files" id="previews" >
                            <div id="template" className="file-row">
                                <div>
                                    <span className="preview"><img alt="thumb" data-dz-thumbnail/></span>
                                </div>
                                <div>
                                    <p className="name" data-dz-name></p>
                                    <strong className="error text-danger" data-dz-errormessage></strong>
                                </div>
                                <div>
                                    <p className="size" data-dz-size></p>
                                    <div className="progress progress-striped active" role="progressbar"
                                         aria-valuemin="0"
                                         aria-valuemax="100" aria-valuenow="0">
                                        <div className="progress-bar progress-bar-success"
                                             data-dz-uploadprogress></div>
                                    </div>
                                </div>
                                <div className="button-container">
                                    <button data-dz-remove className="btn btn-danger delete">
                                        <span>X</span>
                                    </button>
                                </div>
                            </div>
                        </div>
                    )
                }}

                action={config.BASE_URL + '/api/upload'}
            />
            <br/>
            <br/>
            <hr/>

            <h4 className="form-header">Audio <span>{localization.audio_upload_help}</span></h4>
            <DropzoneComponent
                config={imageComponentConfig}
                eventHandlers={eventHandlers}

                djsConfig={{
                    addRemoveLinks: false,
                    acceptedFiles: "audio/mpeg,audio/mp3",
                    maxFilesize:2,
                    maxFiles:1,
                    timeout:180000,
                    dictDefaultMessage: localization.upload_audio,

                    params: {
                        uid: uid,
                        type: type,
                    },
                    previewTemplate: ReactDOMServer.renderToStaticMarkup(
                        <div className="table table-striped files" id="previews">
                            <div id="template" className="file-row">
                                <div>
                                    {/*<span className="preview"><img alt="thumb" data-dz-thumbnail/></span>*/}
                                </div>
                                <div>
                                    <p className="name" data-dz-name></p>
                                    <strong className="error text-danger" data-dz-errormessage></strong>
                                </div>
                                <div>
                                    <p className="size" data-dz-size></p>
                                    <div className="progress progress-striped active" role="progressbar"
                                         aria-valuemin="0"
                                         aria-valuemax="100" aria-valuenow="0">
                                        <div className="progress-bar progress-bar-success"
                                             data-dz-uploadprogress></div>
                                    </div>
                                </div>
                                <div className="button-container">
                                    <button data-dz-remove className="btn btn-danger delete">
                                        <span>X</span>
                                    </button>
                                </div>
                            </div>
                        </div>
                    )
                }}

                action={config.BASE_URL + '/api/upload'}
            />
            <br/>
            <br/>

            <h4 className="form-header">PDF <span>{localization.pdf_upload_help}</span></h4>
            <DropzoneComponent
                config={imageComponentConfig}
                eventHandlers={eventHandlers}

                djsConfig={{
                    addRemoveLinks: false,
                    acceptedFiles: "application/pdf",
                    maxFilesize:10,
                    maxFiles:1,
                    timeout:180000,
                    dictDefaultMessage: localization.upload_pdf,
                    params: {
                        uid: uid,
                        type: type,
                    },
                    previewTemplate: ReactDOMServer.renderToStaticMarkup(
                        <div className="table table-striped files" id="previews">
                            <div id="template" className="file-row">
                                <div>
                                    {/*<span className="preview"><img alt="thumb" data-dz-thumbnail/></span>*/}
                                </div>
                                <div>
                                    <p className="name" data-dz-name></p>
                                    <strong className="error text-danger" data-dz-errormessage></strong>
                                </div>
                                <div>
                                    <p className="size" data-dz-size></p>
                                    <div className="progress progress-striped active" role="progressbar"
                                         aria-valuemin="0"
                                         aria-valuemax="100" aria-valuenow="0">
                                        <div className="progress-bar progress-bar-success"
                                             data-dz-uploadprogress></div>
                                    </div>
                                </div>
                                <div className="button-container">
                                    <button data-dz-remove className="btn btn-danger delete">
                                        <span>X</span>
                                    </button>
                                </div>
                            </div>
                        </div>
                    )
                }}

                action={config.BASE_URL + '/api/upload'}
            />
            <br/>
            <br/>
        </div>
    )
}

ConvocatoriaForm = reduxForm({
    form: 'ConvocatoriaForm', // a unique identifier for this form
    validate, // <--- validation function given to redux-form
    warn, // <--- warning function given to redux-form
    onSubmit: submit       // submit function must be passed to onSubmit


})(ConvocatoriaForm)

const selector = formValueSelector('ConvocatoriaForm') //< --same as form name
ConvocatoriaForm = connect(
    state => {

        // or together as a group
        const hasNamesValue = selector(state, 'names')
        const hasGroupValue = selector(state, 'group');
        // const summaryLength = selector(state, 'summary');
        const values = getFormValues('ConvocatoriaForm')(state);

        if (state.form.ConvocatoriaForm) {
            if (state.form.ConvocatoriaForm.values) {
                localStorage.setItem('values-' + values.type, JSON.stringify(state.form.ConvocatoriaForm.values));
            }
        }

        return {
            hasNamesValue,
            hasGroupValue,
            // summaryLength,
            // values,
        }
    }
)(ConvocatoriaForm)

export default ConvocatoriaForm
