import * as config from "../../config/config";
import axios from 'axios';

// const FILE_FIELD_NAME = 'files';

// export const djsConfigImage = {
//     addRemoveLinks: false,
//     acceptedFiles: "image/jpeg,image/png,image/gif",
//     // params: {
//     //     uid : getId(),
//     // },
//     previewTemplate: ReactDOMServer.renderToStaticMarkup(
//         <div className="table table-striped files" id="previews">
//             <div id="template" className="file-row">
//                 <div>
//                     <span className="preview"><img data-dz-thumbnail /></span>
//                 </div>
//                 <div>
//                     <p className="name" data-dz-name></p>
//                     <strong className="error text-danger" data-dz-errormessage></strong>
//                 </div>
//                 <div>
//                     <p className="size" data-dz-size></p>
//                     <div className="progress progress-striped active" role="progressbar" aria-valuemin="0"
//                          aria-valuemax="100" aria-valuenow="0">
//                         <div className="progress-bar progress-bar-success" data-dz-uploadprogress></div>
//                     </div>
//                 </div>
//                 <div>
//                     <button data-dz-remove className="btn btn-danger delete">
//                         <span>Delete</span>
//                     </button>
//                 </div>
//             </div>
//         </div>
//     )
// };

export const componentConfig = {
    iconFiletypes: ['.jpg', '.png', '.gif'],
    showFiletypeIcon: true,
    //postUrl: '/uploadHandler'
};

export const imageComponentConfig = {
    iconFiletypes: ['.jpg', '.png', '.gif'],
    showFiletypeIcon: true,
    //postUrl: '/uploadHandler'
};

/**
 * If you want to attach multiple callbacks, simply
 * create an array filled with all your callbacks.
 * @type {Array}
 */
const callbackArray = [
    function () {
        console.log('Look Ma, I\'m a callback in an array!');
    },
    function () {
        console.log('Wooooow!');
    }
];

export const removeCallBack = (data) => {
    console.log(data);
    if (data.xhr) {

        const attachment_id = JSON.parse(data.xhr.responseText)['attachment_id'];
        const name = JSON.parse(data.xhr.responseText)['name'];
        console.log(attachment_id);

        axios.get(config.BASE_URL + '/api/delete-attachment/' + attachment_id + '/' + name)
            .then(function (response) {
                console.log(response);
                console.log('attachment deleted');
            })
            .catch(function (error) {
                console.log(error);
            });
    }
}
/**
 * Simple callbacks work too, of course.
 */
export const simpleCallBack = function (data) {
    console.log('I\'m a simple callback');
    console.log(data);
};

export const eventHandlers = {
    // All of these receive the event as first parameter:
    drop: callbackArray,
    dragstart: null,
    dragend: null,
    dragenter: null,
    dragover: null,
    dragleave: null,
    // All of these receive the file as first parameter:
    addedfile: simpleCallBack,
    removedfile: removeCallBack,
    thumbnail: null,
    error: null,
    processing: null,
    uploadprogress: null,
    sending: null,
    success: null,
    complete: null,
    canceled: null,
    maxfilesreached: null,
    maxfilesexceeded: null,
    // All of these receive a list of files as first parameter
    // and are only called if the uploadMultiple option
    // in djsConfig is true:
    processingmultiple: null,
    sendingmultiple: null,
    successmultiple: null,
    completemultiple: null,
    canceledmultiple: null,
    // Special Events
    totaluploadprogress: null,
    reset: null,
    queuecompleted: null
}