export const validate = (values, props) => {

    const errors = {}
    if (values) {

        if (!values.names) {
            errors.names = props.localization.required
        } else if (values.names.length < 2) {
            errors.names = props.localization.text_is_too_short
        }
        if (!values.surname) {
            errors.surname = props.localization.required
        } else if (values.surname.length < 2) {
            errors.surname = props.localization.text_is_too_short
        }

        if (!values.email) {
            errors.email = props.localization.required
        } else if (!/^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}$/i.test(values.email)) {
            errors.email = props.localization.email_is_not_valid
        }




        if (!values.dni_type) {
            errors.dni_type = props.localization.required
        }



        if (!values.dni) {
            errors.dni = props.localization.required
        }

        if (!values.address) {
            errors.address = props.localization.required
        }

        if (!values.city) {
            errors.city = props.localization.required
        }

        if (!values.country_id) {
            errors.country_id = props.localization.required
        }
        if (!values.nacionality) {
            errors.nacionality = props.localization.required
        }

        if (!values.birthdate) {
            errors.birthdate = props.localization.required
        }

        if (!values.telephone) {
            errors.telephone = props.localization.required
        }

        if (!values.cellphone) {
            errors.cellphone = props.localization.required
        }


        if (values.type === 'artists') {
            if (!values.tags) {
                errors.tags = props.localization.required
            } else if (values.tags.length < 1) {
                errors.tags = props.localization.at_least_one_option
            }

        }
        if (!values.project_title) {
            errors.project_title = props.localization.required
        }

        if (!values.summary) {
            errors.summary = props.localization.required
        } else if (values.summary.length > 1000) {
            errors.summary = props.localization.text_is_too_long + ' - ' + values.summary.length + ' max 1000'
        }

        if (!values.description) {
            errors.description = props.localization.required
        }

        if (!values.space) {
            errors.space = props.localization.required
        }
        if (!values.estimated_budget) {
            errors.estimated_budget = props.localization.required
        }
        // if (!values.complementary_info) {
        //     errors.complementary_info = props.localization.required
        // }
        if (!values.members || !values.members.length) {

        } else {

            const membersArrayErrors = []
            values.members.forEach((member, memberIndex) => {
                const memberErrors = {}
                if (!member || !member.names) {
                    memberErrors.names = props.localization.required
                    membersArrayErrors[memberIndex] = memberErrors
                } else if (member.names.length < 2) {
                    memberErrors.names = props.localization.text_is_too_short
                }
                if (!member || !member.surname) {
                    memberErrors.surname = props.localization.required
                    membersArrayErrors[memberIndex] = memberErrors
                } else if (member.surname.length < 2) {
                    memberErrors.surname = props.localization.text_is_too_short
                }
                if (!member || !member.email) {
                    memberErrors.email = props.localization.required
                    membersArrayErrors[memberIndex] = memberErrors
                } else if (!/^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}$/i.test(member.email)) {
                    memberErrors.email = props.localization.email_is_not_valid
                    membersArrayErrors[memberIndex] = memberErrors
                }
                if (!member || !member.dni_type) {
                    memberErrors.dni_type = props.localization.required
                    membersArrayErrors[memberIndex] = memberErrors
                }

                if (!member || !member.dni) {
                    memberErrors.dni = props.localization.required
                    membersArrayErrors[memberIndex] = memberErrors
                }

                if (!member || !member.address) {
                    memberErrors.address = props.localization.required
                    membersArrayErrors[memberIndex] = memberErrors
                }
                if (!member || !member.city) {
                    memberErrors.city = props.localization.required
                    membersArrayErrors[memberIndex] = memberErrors
                }
                if (!member || !member.birthdate) {
                    memberErrors.birthdate = props.localization.required
                    membersArrayErrors[memberIndex] = memberErrors
                }

                if (!member || !member.country_id) {
                    memberErrors.country_id = props.localization.required
                    membersArrayErrors[memberIndex] = memberErrors
                }

                if (!member || !member.nacionality) {
                    memberErrors.nacionality = props.localization.required
                    membersArrayErrors[memberIndex] = memberErrors
                }

                if (!member || !member.telephone) {
                    memberErrors.telephone = props.localization.required
                    membersArrayErrors[memberIndex] = memberErrors
                }

                if (!member || !member.cellphone) {
                    memberErrors.cellphone = props.localization.required
                    membersArrayErrors[memberIndex] = memberErrors
                }

                if (membersArrayErrors.length) {
                    errors.members = membersArrayErrors
                }
            })
        }
    }



    return errors
}

export const warn = values => {
    const warnings = {}
    if (values.age < 19) {
        warnings.age = 'Hmm, you seem a bit young...'
    }
    return warnings
}