import 'core-js/es6/map';
import 'core-js/es6/set';
import React from 'react';
import ReactDOM from 'react-dom';
import './index.css';
import App from './components/App';



import {Provider} from 'react-redux';
import configureStore from './store/configureStore';
import initialState from './store/initialState';
import {getTypes} from "./actions/typeActions";
import {setType} from "./actions/typeActions";
import {getTags} from "./actions/tagActions";
import {setLang} from "./actions/langActions";
import { getCountries} from "./actions/countryActions";
import MuiThemeProvider from 'material-ui/styles/MuiThemeProvider';
import getMuiTheme from 'material-ui/styles/getMuiTheme';
import './styles/css/app.css';
import {getLocalization} from "./actions/localizationActions";
import {getId} from "./actions/idActions";
// import {black} from 'material-ui/styles/colors';
// import {red500} from 'material-ui/styles/colors';
// import {setDefaultValues} from "./actions/formActions";
// import registerServiceWorker from './registerServiceWorker';
const store = configureStore(initialState);
const rootEl = document.getElementById('root');
store.dispatch(getId(initialState.id, rootEl.getAttribute('data-type'), rootEl.getAttribute('data-lang')));



// const type = rootEl.getAttribute('data-type');

// store.dispatch(setDefaultValues(
//     localStorage.getItem('localID-' + type),
//     type
// ))
// const muiTheme = getMuiTheme({
//     textField: {
//         textColor:black,
//         // hintColor: black,
//         // floatingLabelColor: black,
//         // disabledTextColor: black,
//         // // errorColor: red500,
//         // // focusColor: red500,
//         // backgroundColor: 'transparent',
//         // borderColor: black,
//     },
//
// });
// const muiTheme = getMuiTheme({
// palette: {
//     borderColor: "#3e2723",
//     disabledColor: "rgba(0, 0, 0, 1)",
//     primary1Color: "#8bc34a",
//     accent1Color: "#4e342e"
// }
// });

if (!Array.prototype.includes) {
    Object.defineProperty(Array.prototype, 'includes', {
        value: function(searchElement, fromIndex) {

            if (this == null) {
                throw new TypeError('"this" es null o no está definido');
            }

            // 1. Dejar que O sea ? ToObject(this value).
            var o = Object(this);

            // 2. Dejar que len sea ? ToLength(? Get(O, "length")).
            var len = o.length >>> 0;

            // 3. Si len es 0, devuelve false.
            if (len === 0) {
                return false;
            }

            // 4. Dejar que n sea ? ToInteger(fromIndex).
            //    (Si fromIndex no está definido, este paso produce el valor 0.)
            var n = fromIndex | 0;

            // 5. Si n ≥ 0, entonces
            //  a. Dejar que k sea n.
            // 6. Else n < 0,
            //  a. Dejar que k sea len + n.
            //  b. Si k < 0, Dejar que k sea 0.
            var k = Math.max(n >= 0 ? n : len - Math.abs(n), 0);

            function sameValueZero(x, y) {
                return x === y || (typeof x === 'number' && typeof y === 'number' && isNaN(x) && isNaN(y));
            }

            // 7. Repite, mientras k < len
            while (k < len) {
                // a. Dejar que elementK sea el resultado de ? Get(O, ! ToString(k)).
                // b. Si SameValueZero(searchElement, elementK) es true, devuelve true.
                if (sameValueZero(o[k], searchElement)) {
                    return true;
                }
                // c. Incrementa k por 1.
                k++;
            }

            // 8. Devuelve false
            return false;
        }
    });
}

if (!FileList.prototype.map) {
    FileList.prototype.map = function(callback) {
        var T, A, k;

        if (this == null) {
            throw new TypeError('this is null or not defined');
        }

        var O = Object(this);
        var len = O.length >>> 0;

        if (typeof callback !== 'function') {
            throw new TypeError(callback + ' is not a function');
        }

        if (arguments.length > 1) {
            T = arguments[1];
        }

        A = new Array(len);

        k = 0;

        while (k < len) {

            var kValue, mappedValue;
            if (k in O) {
                kValue = O[k];
                mappedValue = callback.call(T, kValue, k, O);
                A[k] = mappedValue;
            }
            k++;
        }
        return A;
    };
}


// Production steps of ECMA-262, Edition 6, 22.1.2.1
// Reference: https://people.mozilla.org/~jorendorff/es6-draft.html#sec-array.from
if (!Array.from) {
    Array.from = (function () {
        var toStr = Object.prototype.toString;
        var isCallable = function (fn) {
            return typeof fn === 'function' || toStr.call(fn) === '[object Function]';
        };
        var toInteger = function (value) {
            var number = Number(value);
            if (isNaN(number)) { return 0; }
            if (number === 0 || !isFinite(number)) { return number; }
            return (number > 0 ? 1 : -1) * Math.floor(Math.abs(number));
        };
        var maxSafeInteger = Math.pow(2, 53) - 1;
        var toLength = function (value) {
            var len = toInteger(value);
            return Math.min(Math.max(len, 0), maxSafeInteger);
        };
        // The length property of the from method is 1.
        return function from(arrayLike/*, mapFn, thisArg */) {
            // 1. Let C be the this value.
            var C = this;
            // 2. Let items be ToObject(arrayLike).
            var items = Object(arrayLike);
            // 3. ReturnIfAbrupt(items).
            if (arrayLike == null) {
                throw new TypeError("Array.from requires an array-like object - not null or undefined");
            }
            // 4. If mapfn is undefined, then let mapping be false.
            var mapFn = arguments.length > 1 ? arguments[1] : void undefined;
            var T;
            if (typeof mapFn !== 'undefined') {
                // 5. else
                // 5. a If IsCallable(mapfn) is false, throw a TypeError exception.
                if (!isCallable(mapFn)) {
                    throw new TypeError('Array.from: when provided, the second argument must be a function');
                }
                // 5. b. If thisArg was supplied, let T be thisArg; else let T be undefined.
                if (arguments.length > 2) {
                    T = arguments[2];
                }
            }
            // 10. Let lenValue be Get(items, "length").
            // 11. Let len be ToLength(lenValue).
            var len = toLength(items.length);
            // 13. If IsConstructor(C) is true, then
            // 13. a. Let A be the result of calling the [[Construct]] internal method of C with an argument list containing the single item len.
            // 14. a. Else, Let A be ArrayCreate(len).
            var A = isCallable(C) ? Object(new C(len)) : new Array(len);
            // 16. Let k be 0.
            var k = 0;
            // 17. Repeat, while k < len… (also steps a - h)
            var kValue;
            while (k < len) {
                kValue = items[k];
                if (mapFn) {
                    A[k] = typeof T === 'undefined' ? mapFn(kValue, k) : mapFn.call(T, kValue, k);
                } else {
                    A[k] = kValue;
                }
                k += 1;
            }
            // 18. Let putStatus be Put(A, "length", len, true).
            A.length = len;
            // 20. Return A.
            return A;
        };
    }());
}


store.dispatch(getTypes(initialState.types));
store.dispatch(setLang(rootEl.getAttribute('data-lang')));
store.dispatch(setType(rootEl.getAttribute('data-type')));

store.dispatch(getTags(initialState.tags));
store.dispatch(getLocalization(initialState.localization));
store.dispatch(getCountries(initialState.countries));

ReactDOM.render(
    <Provider store={store}>
        <MuiThemeProvider muiTheme={getMuiTheme()}>
            <App/>
        </MuiThemeProvider>
    </Provider>
    ,
    rootEl
);

// registerServiceWorker();
