@extends('admin.layouts.app')
@section('content')
	<div class="page-header">
	    <h1 >Ver Detalle</h1>
		<input type="button" name="imprimir" value="Imprimir Inscripci&oacute;n" class="btn btn-success" onclick="window.print();">
	</div>

	<div class="panel panel-default">
	  <div class="panel-heading">
	    <h3 class="panel-title">Información personal</h3>
	  </div>
	  <div class="panel-body">
	    <form class="form-horizontal">
		  
		  <div class="form-group">
		    <label for="" class="col-sm-3">Nombre</label>
		    <div class="col-sm-9">
		      {{ $usuario->name }}
		    </div>
		  </div>

		  <div class="form-group">
		    <label for="" class="col-sm-3">Apellido</label>
		    <div class="col-sm-9">
		      {{ $usuario->surname }}
		    </div>
		  </div>

		  <div class="form-group">
		    <label for="" class="col-sm-3">Email</label>
		    <div class="col-sm-9">
		      {{ $usuario->email }}
		    </div>
		  </div>

		  <div class="form-group">
		    <label for="" class="col-sm-3">DNI</label>
		    <div class="col-sm-9">
		      {{ $usuario->dni_type . ': ' . $usuario->dni }}
		    </div>
		  </div>

		  <div class="form-group">
		    <label for="" class="col-sm-3">Dirección</label>
		    <div class="col-sm-9">
		      {{ $usuario->address }}
		    </div>
		  </div>

		  <div class="form-group">
		    <label for="" class="col-sm-3">Ciudad</label>
		    <div class="col-sm-9">
		      {{ $usuario->city }}
		    </div>
		  </div>

		  <div class="form-group">
		    <label for="" class="col-sm-3">País</label>
		    <div class="col-sm-9">
		      {{ $usuario->pais }}
		    </div>
		  </div>

		  <div class="form-group">
		    <label for="" class="col-sm-3">Nacionalidad</label>
		    <div class="col-sm-9">
		      {{ $usuario->nacionality }}
		    </div>
		  </div>

		  <div class="form-group">
		    <label for="" class="col-sm-3">Fecha de nacimiento</label>
		    <div class="col-sm-9">
				@php($date = new DateTime($usuario->birthdate))
		      {{ date_format($date, 'd/m/y') }}
		    </div>
		  </div>

		  <div class="form-group">
		    <label for="" class="col-sm-3">Teléfono fijo</label>
		    <div class="col-sm-9">
		      {{ $usuario->telephone }}
		    </div>
		  </div>

		  <div class="form-group">
		    <label for="" class="col-sm-3">Teléfono móvil</label>
		    <div class="col-sm-9">
		      {{ $usuario->cellphone }}
		    </div>
		  </div>

		</form>
	  </div>
	</div>

	<div class="panel panel-default">
	  <div class="panel-heading">
	    <h3 class="panel-title">Detalle</h3>
	  </div>
	  <div class="panel-body">
	    <form class="form-horizontal">
		  
		  <div class="form-group">
		    <label for="" class="col-sm-3">Usuario</label>
		    <div class="col-sm-9">
		      {{ $usuario->name }}
		    </div>
		  </div>

		  <div class="form-group">
		    <label for="" class="col-sm-3">Tipo</label>
		    <div class="col-sm-9">
		      {{ $proyecto->type }}
		    </div>
		  </div>

		  <div class="form-group">
		    <label for="" class="col-sm-3">Tipo de presentación</label>
		    <div class="col-sm-9">
			    @if(is_null($proyecto->team_id))
					individual
				@else
					grupo
				@endif
		    </div>
		  </div>

		  @if(!is_null($proyecto->team_id))
			  <div class="form-group">
			    <label for="" class="col-sm-3">Nombre del grupo</label>
			    <div class="col-sm-9">
				    {{ $grupo->first()->nombreGrupo }}
			    </div>
			  </div>
		  @endif

		  <div class="form-group">
		    <label for="" class="col-sm-3">Título</label>
		    <div class="col-sm-9">
		      {{ $proyecto->title }}
		    </div>
		  </div>

		  <div class="form-group">
			<label for="" class="col-sm-3">Tipo de proyecto</label>
			@if(!is_null($tipo_proyecto))
				<div class="col-sm-9">
					{{ $tipo_proyecto->tipo_proyecto }}
				</div>
			@endif
		  </div>

		  <div class="form-group">
		    <label for="" class="col-sm-3">Resumen</label>
		    <div class="col-sm-9">
		      {{ $proyecto->summary }}
		    </div>
		  </div>

		  <div class="form-group">
		    <label for="" class="col-sm-3">Descripcion</label>
		    <div class="col-sm-9">
		      {{ $proyecto->description }}
		    </div>
		  </div>

		  <div class="form-group">
		    <label for="" class="col-sm-3">Espacio</label>
		    <div class="col-sm-9">
		      {{ $proyecto->space }}
		    </div>
		  </div>

		  <div class="form-group">
		    <label for="" class="col-sm-3">Presupuesto</label>
		    <div class="col-sm-9">
		      {{ $proyecto->estimated_bucket }}
		    </div>
		  </div>

		  <div class="form-group">
		    <label for="" class="col-sm-3">Informacion complementaria</label>
		    <div class="col-sm-9">
		      {{ $proyecto->complementary_info }}
		    </div>
		  </div>
		  @if(!is_null($proyecto->material_link))
		  		{{-- @if(preg_match('#^(https?://|www\.)#i', $proyecto->material_link) === 1) --}}
				  <div class="form-group">
				    <label for="" class="col-sm-3">Materiales - video</label>
				    <a href="{{$proyecto->material_link}}" target="_blank">{{$proyecto->material_link}}</a>
				    {{-- <div class="col-sm-9">
			      		<iframe width="420" height="315" src="{{$proyecto->material_link}}" frameborder="0" allowfullscreen></iframe>
				    </div> --}}
				  </div>
				{{-- @endif --}}
		  @endif

		  @if(!is_null($proyecto->material_password))
			  <div class="form-group">
			    <label for="" class="col-sm-3">Materiales - password</label>
			    <div class="col-sm-9">
			      {{ $proyecto->material_password }}
			    </div>
			  </div>
          @endif

		</form>
	  </div>
	</div>

	@if(!is_null($proyecto->team_id))
		<div class="panel panel-default">
			<div class="panel-heading">
				<h3 class="panel-title">Integrantes del grupo</h3>
			</div>

			@foreach($grupo as $integrante)
				<div class="panel-body">
					<form class="form-horizontal">
					  <div class="form-group">
					    <label for="" class="col-sm-3">Nombre</label>
					    <div class="col-sm-9">
					      {{ $integrante->name }}
					    </div>
					  </div>

					  <div class="form-group">
					    <label for="" class="col-sm-3">Apellido</label>
					    <div class="col-sm-9">
					      {{ $integrante->surname }}
					    </div>
					  </div>

					  <div class="form-group">
					    <label for="" class="col-sm-3">Email</label>
					    <div class="col-sm-9">
					      {{ $integrante->email }}
					    </div>
					  </div>

					  <div class="form-group">
					    <label for="" class="col-sm-3">DNI</label>
					    <div class="col-sm-9">
					      {{ $integrante->dni_type . ': ' . $integrante->dni }}
					    </div>
					  </div>

					  <div class="form-group">
					    <label for="" class="col-sm-3">Dirección</label>
					    <div class="col-sm-9">
					      {{ $integrante->address }}
					    </div>
					  </div>

					  <div class="form-group">
					    <label for="" class="col-sm-3">Ciudad</label>
					    <div class="col-sm-9">
					      {{ $integrante->city }}
					    </div>
					  </div>

					  <div class="form-group">
					    <label for="" class="col-sm-3">País</label>
					    <div class="col-sm-9">
					      {{ $integrante->pais }}
					    </div>
					  </div>

					  <div class="form-group">
					    <label for="" class="col-sm-3">Nacionalidad</label>
					    <div class="col-sm-9">
					      {{ $integrante->nacionality }}
					    </div>
					  </div>

					  <div class="form-group">
					    <label for="" class="col-sm-3">Fecha de nacimiento</label>
					    <div class="col-sm-9">
							@php($date = new DateTime($integrante->birthdate))
					      {{ date_format($date, 'd/m/y') }}
					    </div>
					  </div>

					  <div class="form-group">
					    <label for="" class="col-sm-3">Teléfono fijo</label>
					    <div class="col-sm-9">
					      {{ $integrante->telephone }}
					    </div>
					  </div>

					  <div class="form-group">
					    <label for="" class="col-sm-3">Teléfono móvil</label>
					    <div class="col-sm-9">
					      {{ $integrante->cellphone }}
					    </div>
					  </div>

					</form>
					<hr>
				</div>
			@endforeach
		</div>
	@endif


	<div class="panel panel-default">
	  <div class="panel-heading">
	    <h3 class="panel-title">Archivos adjuntos</h3>
	  </div>
	  <div class="panel-body">
	    <form class="form-horizontal">
		  
		@foreach($adjuntos as $key => $adj)
			<div class="form-group">
				@switch($adj['mime'])
					@case("image-jpeg")
					@case("image-jp2")
					@case("image-png")
						@php($tipo_de_adjunto = "Imagen")
						@break

					@case("audio-mpeg")
						@php($tipo_de_adjunto = "Audio")
						@break

					@case("video-mp4")
					@case("video-x-m4v")
						@php($tipo_de_adjunto = "Video")
						@break

					@default
						@php($tipo_de_adjunto = "")
				@endswitch
	
			    <label for="" class="col-sm-3">{{ $tipo_de_adjunto }}</label>
			
			<div class="col-sm-9">
		    	@switch($adj['mime'])
					@case("image-jpeg")
					@case("image-jp2")
					@case("image-png")
						@php($imagen = $adj['path'] . $adj['filename'])
						<a href="#" data-toggle="modal" data-target="#myModal">
							<img src="{{ asset(str_replace('#', '%23', $imagen)) }}" style="width: 300px;">
						</a>

						@break
					
					@case("audio-mpeg")
						@php($audio = $adj['path'] . $adj['filename'])
						<audio controls>
						  <source src="{{ asset($audio) }}" type="audio/ogg">
						  <source src="{{ asset($audio) }}" type="audio/mpeg">
						Your browser does not support the audio element.
						</audio>
						@break

					@case("video-mp4")
					@case("video-x-m4v")
						@php($video = $adj['path'] . $adj['filename'])
						<video width="400" controls>
						  <source src="{{ asset($video) }}" type="video/mp4">
						  <source src="{{ asset($video) }}" type="video/ogg">
						  Your browser does not support HTML5 video.
						</video>
						@break

					@default
						@php($tipo_de_adjunto = "")
				@endswitch
		    </div>

		    {{-- MODAL de imagen --}}
				<div class="modal fade fullscreen-modal" tabindex="-1" role="dialog" id="myModal">
				  <div class="modal-dialog" role="document">
				    <div class="modal-content">
				      {{-- <div class="modal-header">
				        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
				        <h4 class="modal-title">Modal title</h4>
				      </div> --}}
				      <div class="modal-body text-center">
				        
						{{-- CAROUSEL --}}
				        <div id="carousel-example-generic" class="carousel slide" data-ride="carousel">
							@php($sliderActivo = "")
							@php($sliderIndicador = "")
						  <!-- Indicators -->
						  <ol class="carousel-indicators">
						  	@foreach($adjuntos as $keyIndicador => $adjIndicador)
						  		@if(in_array($adjIndicador['mime'], [1 => "image-jpeg", 2 => "image-jp2", 3 => "image-png"]))
								  	@if($keyIndicador == 0)
										@php($sliderIndicador = "active")
									@else
										@php($sliderIndicador = "")
								  	@endif
						    	
						    		<li data-target="#carousel-example-generic" data-slide-to="{{ $keyIndicador }}" class="{{$sliderIndicador}}"></li>
								@endif
						    @endforeach
						  </ol>

						  <!-- Wrapper for slides -->
						  <div class="carousel-inner" role="listbox">
						  	@foreach($adjuntos as $keySlider => $adjSlider)
						  		@if(in_array($adjSlider['mime'], [1 => "image-jpeg", 2 => "image-jp2", 3 => "image-png"]))
								  	@php($imagenSlider = $adjSlider['path'] . $adjSlider['filename'])
								  	@if($keySlider == 0)
										@php($sliderActivo = "active")
									@else
										@php($sliderActivo = "")
								  	@endif
								    <div class="item {{$sliderActivo}}">
								      <img src="{{ asset(str_replace('#', '%23', $imagenSlider)) }}" style="width: 100%;">
								    </div>
							    @endif
						    @endforeach
						  </div>

						  <!-- Controls -->
						  <a class="left carousel-control" href="#carousel-example-generic" role="button" data-slide="prev">
						    <span class="glyphicon glyphicon-chevron-left" aria-hidden="true"></span>
						    <span class="sr-only">Previous</span>
						  </a>
						  <a class="right carousel-control" href="#carousel-example-generic" role="button" data-slide="next">
						    <span class="glyphicon glyphicon-chevron-right" aria-hidden="true"></span>
						    <span class="sr-only">Next</span>
						  </a>
						</div>
				      </div>
				      {{-- <div class="modal-footer">
				        <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
				        <button type="button" class="btn btn-primary">Save changes</button>
				      </div> --}}
				    </div><!-- /.modal-content -->
				  </div><!-- /.modal-dialog -->
				</div><!-- /.modal -->
			{{-- FIN modal --}}
		  </div>
		@endforeach

		  
		</form>
	  </div>
	</div>


	{{-- Reseñas --}}
	<div class="panel panel-default">
        <div class="panel-heading">
            <h3 class="panel-title">Agregar reseña (Revisor)</h3>
        </div>

        {{-- Mensajes --}}
        <div class="row">
            <div class="col-xs-12 col-sm-7 col-sm-offset-3">
                {{-- De error --}}
                @if ($errors->any())
                    <div class="alert alert-danger">
                        <ul>
                            @foreach ($errors->all() as $error)
                                <li>{{ $error }}</li>
                            @endforeach
                        </ul>
                    </div>
                @endif
                
                {{-- De exito --}}
                @if(Session::has('reseniaGuardada'))
                    <div class="alert alert-success" role="alert">
                        {{Session::get('reseniaGuardada', '')}}
                    </div>
                @endif
            </div>  
        </div>

      
        <div class="panel-body">

            {!! Form::open(array('route' => 'review.store',  'method' => 'POST','enctype'=>"multipart/form-data", 'class' => 'form-horizontal')) !!}

	            {!! Form::token() !!}

	            {{ Form::hidden('idProject', $proyecto->id) }}
	            {{ Form::hidden('idRevisor', \Auth::id()) }}


	            <div class="form-group">
	                {!! Form::label('', 'Comentario:', ['class' => 'col-sm-3']) !!}
	                <div class="col-sm-9">
	                    {!! Form::textarea('comment', '', ['class' => 'form-control']) !!}
	                </div>
	            </div>

	            <div class="form-group">
	                {!! Form::label('', 'Puntaje:', ['class' => 'col-sm-3']) !!}
	                <div class="col-sm-9">
	                    {!! Form::select('rating', $arrayRating, null, ['placeholder' => 'Elegir']) !!}
	                </div>
	            </div>

	            <div class="form-group text-center">
	                {!! Form::submit() !!}<br>
	            </div>


            {!! Form::close() !!}
        </div>
    </div>

    <div class="panel panel-default">
        <div class="panel-heading">
            <h3 class="panel-title">Reseñas</h3>
        </div>

        <div class="panel-body">
			<div class="table-responsive">		
		      	<table class="table table-striped">
		      		<thead>
		      			<th>Revisor</th>
		      			<th>Comentario</th>
		      			<th>Puntaje</th>
		      			<th>Acción</th>
		      		</thead>
					
					<tbody>
						@foreach($reseniasDelProyecto as $resenia)
							<tr>
								<td>
									{{ $resenia->nombreRevisor }}
								</td>
								<td>
									{{ $resenia->comment }}
								</td>
								<td>
									{{ $resenia->rating }}
								</td>
								<td>
									<a class="btn btn-primary btn-xs editarComentario" id="{{$resenia->id}}">Editar</a>
								</td>
							</tr>

							<tr style="display: none;" id="mostrar{{$resenia->id}}">
								<td>
									{{ $resenia->nombreRevisor }}
								</td>

								{!! Form::open(array('route' => ['review.update', $resenia->id],  'method' => 'PATCH','enctype'=>"multipart/form-data", 'class' => 'form-horizontal')) !!}

						            {!! Form::token() !!}

									<td>
							            <div class="form-group">
							                <div class="col-sm-9">
							                    {!! Form::textarea('comment', $resenia->comment, ['class' => 'form-control']) !!}
							                </div>
							            </div>
									</td>

									<td>
							            <div class="form-group">
							                <div class="col-sm-9">
							                    {!! Form::select('rating', $arrayRating, $resenia->rating, ['placeholder' => 'Elegir']) !!}
							                </div>
							            </div>
									</td>

									<td>
							            <div class="form-group text-center">
							                {!! Form::submit('Guardar cambios', ['class' => 'btn btn-primary btn-xs']) !!}<br>
							            </div>										
									</td>

						            {!! Form::close() !!}

								<td>
									<a class="btn btn-primary btn-xs cancelarComentario" id="{{$resenia->id}}">Cancelar</a>
								</td>
							</tr>
						@endforeach
					</tbody>
		      	</table>
			</div>
        </div>
    </div>
    

@endsection

@section('scripts')


    <script type="text/javascript">
        $(document).ready(function ($) {
        	$('.editarComentario').click(function(){
        		var varId = this.id;
        		$('#mostrar' + varId).show();
        	});

        	$('.cancelarComentario').click(function(){
        		var varId = this.id;
        		$('#mostrar' + varId).hide();
        	});

        });

    </script>
@endsection