@extends('admin.layouts.app')
@section('content')
    <div class="page-header">
        <div class="row">
            <div class="col-xs-12">
                <h1>Proyectos archivados</h1>        
            </div>
        </div>
    </div>

    <div class="row" style="margin-bottom: 15px;">
        <div class="col-xs-12" style="margin-bottom: 10px;">
                Total proyectos archivados: <b>{{ $total_proyectos }}</b>
        </div>
    </div>


    {{-- proyectos --}}
    <div class="table-responsive">
        <table class="table display table-hover" id="tablaProyectos">
            <thead>
                <tr>
                    <th>Nº</th>
                    <th>Título</th>
                    <th>Ver</th>
                    <th>Restaurar</th>
                </tr>
            </thead>
        
            <tbody>
                @foreach($proyectos as $proyecto)
                    <tr>
                        <td>{{ $proyecto->origin_id }}</td>
                        <td>{{$proyecto->title}}</td>
                        <td>
                            <a class="btn btn-primary" href="{{ URL::to('/') }}/admin/inscription/{{ $proyecto->id }}">Ver proyecto</a>
                        </td>
                        <td>
                            <a class="btn btn-warning" href="{{ URL::to('/') }}/admin/restoreProject/{{ $proyecto->id }}" onclick="return restaurarProyecto('{{$proyecto->title}}')">Restaurar</a>
                        </td>
                    </tr>
                    @endforeach
            </tbody>
        </table>
    </div>

@endsection

@section('scripts')
    <script>
        function restaurarProyecto(titulo) {
            var eligio = confirm("Restaurar proyecto: "+titulo+"?");
            if (eligio == false) {
                return false;
            }
        }
    </script>
@endsection